ACTION!="add", GOTO="librem5_pm_end"

# Enable the simple_ondemand governor for devfreq. other requirements come from interconnect
SUBSYSTEM=="devfreq", TEST=="governor", ATTR{governor}="simple_ondemand"

# Enable power management for external USB bus
DEVPATH=="/devices/platform/soc@0/38100000.usb", TEST=="power/control", ATTR{power/control}="auto"

### Enable power management for internal USB devices:

SUBSYSTEM=="usb", ENV{DEVPATH}=="/devices/platform/soc@0/38200000.usb/xhci-hcd.4.auto/usb1/1-0:1.0", ATTR{usb1-port1/quirks}="10000000"
SUBSYSTEM=="usb", ENV{DEVPATH}=="/devices/platform/soc@0/38200000.usb/xhci-hcd.4.auto/usb1/1-1/1-1:1.0", ATTR{1-1-port2/quirks}="10000000", ATTR{1-1-port3/power/pm_qos_no_power_off}="0"

# Broadmobi BM818
SUBSYSTEM=="usb", ATTR{idVendor}=="2020", ATTR{idProduct}=="2060", TEST=="power/control", ATTR{power/control}="auto"
SUBSYSTEM=="usb", ATTR{idVendor}=="2020", ATTR{idProduct}=="2060", TEST=="power/autosuspend_delay_ms", ATTR{power/autosuspend_delay_ms}="500"
SUBSYSTEM=="usb", ATTR{idVendor}=="2020", ATTR{idProduct}=="2060", TEST=="power/persist", ATTR{power/persist}="0"

# Cinterion PLS8
SUBSYSTEM=="usb", ATTR{idVendor}=="1e2d", ATTR{idProduct}=="0061", TEST=="power/control", ATTR{power/control}="auto"
SUBSYSTEM=="usb", ATTR{idVendor}=="1e2d", ATTR{idProduct}=="0061", TEST=="power/autosuspend_delay_ms", ATTR{power/autosuspend_delay_ms}="500"
SUBSYSTEM=="usb", ATTR{idVendor}=="1e2d", ATTR{idProduct}=="0061", TEST=="power/persist", ATTR{power/persist}="0"

# Sierra Wireless EM7565
SUBSYSTEM=="usb", ATTR{idVendor}=="1199", ATTR{idProduct}=="9091", TEST=="power/control", ATTR{power/control}="auto"
SUBSYSTEM=="usb", ATTR{idVendor}=="1199", ATTR{idProduct}=="9091", TEST=="power/autosuspend_delay_ms", ATTR{power/autosuspend_delay_ms}="500"
SUBSYSTEM=="usb", ATTR{idVendor}=="1199", ATTR{idProduct}=="9091", TEST=="power/persist", ATTR{power/persist}="0"

# SIMCom SIM7912G
SUBSYSTEM=="usb", ATTR{idVendor}=="1e0e", ATTR{idProduct}=="9001", TEST=="power/control", ATTR{power/control}="auto"
SUBSYSTEM=="usb", ATTR{idVendor}=="1e0e", ATTR{idProduct}=="9001", TEST=="power/autosuspend_delay_ms", ATTR{power/autosuspend_delay_ms}="500"
SUBSYSTEM=="usb", ATTR{idVendor}=="1e0e", ATTR{idProduct}=="9001", TEST=="power/persist", ATTR{power/persist}="0"

# Microchip USB2642
SUBSYSTEM=="usb", ATTR{idVendor}=="0424", ATTR{idProduct}=="2640", TEST=="power/control", ATTR{power/control}="auto"
SUBSYSTEM=="usb", ATTR{idVendor}=="0424", ATTR{idProduct}=="2640", TEST=="power/autosuspend_delay_ms", ATTR{power/autosuspend_delay_ms}="0"

# SD card reader
# enable runtime pm
SUBSYSTEM=="module", KERNEL=="block", TEST=="parameters/events_dfl_poll_msecs", ATTR{parameters/events_dfl_poll_msecs}="0"

SUBSYSTEM=="scsi", DRIVER=="sd", TEST=="power/control", ATTR{power/control}="auto"
SUBSYSTEM=="scsi", DRIVER=="sd", TEST=="power/autosuspend_delay_ms", ATTR{power/autosuspend_delay_ms}="500"

SUBSYSTEM=="usb", ATTR{idVendor}=="0424", ATTR{idProduct}=="4041", TEST=="power/control", ATTR{power/control}="auto"
SUBSYSTEM=="usb", ATTR{idVendor}=="0424", ATTR{idProduct}=="4041", TEST=="power/autosuspend_delay_ms", ATTR{power/autosuspend_delay_ms}="0"
# set readahead to 4M
SUBSYSTEMS=="usb", ATTRS{idVendor}=="0424", ATTRS{idProduct}=="4041", TEST=="queue/read_ahead_kb", ATTR{queue/read_ahead_kb}="4096"

LABEL="librem5_pm_end"
